/** author Tim vor der Brck
 * this software is released under the GNU General Public License
 */

#ifndef STRING_PARSER_H
#define STRING_PARSER_H

#include <string>

class StringIterator;

class StringParser
{
  typedef StringIterator const_iterator;
  friend class StringIterator;
 public:
  StringParser(string tokStr,string delim[],int numDelim,bool* include=0,int startPos=0);
  ~StringParser();
  const_iterator& begin();
  const_iterator& end();
  
 protected:
  
  /** position to start the parsing*/
  int m_startPos;

  /** end interator */
  StringIterator* m_endIter;
  
  /** token string*/
  string m_tokStr;

  /** delimiters that divide the tokens*/
  string* m_delim;

  /** number of delimiter*/
  int m_numDelim;

  /** include delimiters in the token*/
  bool* m_include;
};  

class StringIterator
{
  friend class StringParser;
 public:
  string operator*();
  StringIterator& operator++();
  bool operator==(StringIterator& iter);
  bool operator!=(StringIterator& iter);
  StringIterator(StringIterator& iter);

 protected:
  StringIterator(StringParser* parser,int pos=0);
  string findNextToken();
  string m_nextToken;
  StringParser* m_parser;
  int m_pos;
};

  

#endif

